
// MPLABX IDE 6.0
// MPLAB X XC8
// rajout SMT1
// lecture WAV OK
// nota:
//in fine, si on veut controler soit meme le flux,
// il vaut mieux ne pas utiliser le mode RTS de l'UART HARDWARE
//mais de gerer la dortie RC5 -> RTS de l'interface Prolific TTL/USB  (vers terminal)


 /*
 Pin 28  RB7  --x  x----ICSP Data
 Pin 27  RB6  --x  x-----ICSP Clock
 Pin 26  RB5   
 Pin 25  RB4   
 Pin 24  RB3   
 Pin 23  RB2   
 Pin 22  RB1  
 Pin 21  RB0   

 Pin 20  VDD --------+5V  ---------------------------------ou-------HC05 Bcc
 Pin 19  Vss ---------Gnd--- fil noir cable prolific  ---- ou ------HC05 Gnd
 Pin 18  RC7  RX UART  <-- fil Vert prolific Keyboard  Terminal ..ou HC05  TX
 Pin 17  RC6  TX UART  --> fil Blanc prolific Display  Terminal ..ou HC05 RX via 1k/2,7k
 Pin 16  RC5  ---> RTS
 Pin 15  RC4 
 Pin 14  RC3 
 Pin 13  RC2 
 Pin 12  RC1 
 Pin 11  RC0 

 Pin 10  RA6 
 Pin  9  RA7  
 Pin  8  VSS ---------  Gnd
 Pin  7  RA5 
 Pin  6  RA4 
 Pin  5  RA3  
 Pin  4  RA2  
 Pin  3  RA1 
 Pin  2  RA0 
 Pin  1  RE3 MCLR  Reset <--------ICSP PGRM
                         |----x  x----/0V   cavalier RESET
 */

#define VERSION "2022-0912"
// test ecriture /lecture flash   OK_11025.wav
// restitution PWM RC1 //OK


#include <xc.h>
#include <stdint.h>
#include <stdbool.h>
//#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>   // pour sprintf ..etc
#include <stdarg.h>
#include <pic18f27k42.h>

//#warning "use Linker C90 for ultoa"
//#include "mcc_generated_files/mcc.h"


//#define With_NCO
#define With_SMT1
#define With_Test_flash  

#define _XTAL_FREQ 64000000
#define FOSC       64000000              // Fosc=16MHz
#define FCY       (FOSC/4)              // Fcy=4MHz
#define BR        115200                // Baud Rate  UART Speed !!!!
#define BRG       ((FCY/BR)-1)          // brgs=1

#pragma warning disable 1498
#pragma warning disable 31
#pragma warning disable 228   // caractere francais accentu
#pragma warning disable 520  
#pragma warning disable 1510 
#pragma warning disable 759
#pragma warning disable  2053
#pragma warning disable  2020
#pragma warning disable 359
#pragma warning disable 373

//========================================================
//  manual config bits

 // CONFIG1L
#pragma config FEXTOSC = OFF    // External Oscillator Selection->Oscillator not enabled
#pragma config RSTOSC = HFINTOSC_64MHZ    // Reset Oscillator Selection->HFINTOSC with HFFRQ = 64 MHz and CDIV = 1:1

// CONFIG1H
#pragma config CLKOUTEN = OFF    // Clock out Enable bit->CLKOUT function is disabled
#pragma config PR1WAY = ON    // PRLOCKED One-Way Set Enable bit->PRLOCK bit can be cleared and set only once
#pragma config CSWEN = ON    // Clock Switch Enable bit->Writing to NOSC and NDIV is allowed
#pragma config FCMEN = ON    // Fail-Safe Clock Monitor Enable bit->Fail-Safe Clock Monitor enabled

// CONFIG2L
#pragma config MCLRE = EXTMCLR    // MCLR Enable bit->If LVP = 0, MCLR pin is MCLR; If LVP = 1, RE3 pin function is MCLR 
#pragma config PWRTS = PWRT_OFF    // Power-up timer selection bits->PWRT is disabled
#pragma config MVECEN = ON    // Multi-vector enable bit->Multi-vector enabled, Vector table used for interrupts
#pragma config IVT1WAY = OFF    // IVTLOCK bit One-way set enable bit->IVTLOCK bit can be cleared and set repeatedly
#pragma config LPBOREN = OFF    // Low Power BOR Enable bit->ULPBOR disabled
#pragma config BOREN = SBORDIS    // Brown-out Reset Enable bits->Brown-out Reset enabled , SBOREN bit is ignored

// CONFIG2H
#pragma config BORV = VBOR_2P45    // Brown-out Reset Voltage Selection bits->Brown-out Reset Voltage (VBOR) set to 2.45V
#pragma config ZCD = OFF    // ZCD Disable bit->ZCD disabled. ZCD can be enabled by setting the ZCDSEN bit of ZCDCON
#pragma config PPS1WAY = OFF    // PPSLOCK bit One-Way Set Enable bit->PPSLOCK bit can be set and cleared repeatedly (subject to the unlock sequence)
#pragma config STVREN = ON    // Stack Full/Underflow Reset Enable bit->Stack full/underflow will cause Reset
#pragma config DEBUG = OFF    // Debugger Enable bit->Background debugger disabled
#pragma config XINST = OFF    // Extended Instruction Set Enable bit->Extended Instruction Set and Indexed Addressing Mode disabled

// CONFIG3L
#pragma config WDTCPS = WDTCPS_31    // WDT Period selection bits->Divider ratio 1:65536; software control of WDTPS
#pragma config WDTE = OFF    // WDT operating mode->WDT Disabled; SWDTEN is ignored

// CONFIG3H
#pragma config WDTCWS = WDTCWS_7    // WDT Window Select bits->window always open (100%); software control; keyed access not required
#pragma config WDTCCS = SC    // WDT input clock selector->Software Control

// CONFIG4L
#pragma config BBSIZE = BBSIZE_512    // Boot Block Size selection bits->Boot Block size is 512 words
#pragma config BBEN = OFF    // Boot Block enable bit->Boot block disabled
#pragma config SAFEN = OFF    // Storage Area Flash enable bit->SAF disabled
#pragma config WRTAPP = OFF    // Application Block write protection bit->Application Block not write protected

// CONFIG4H
#pragma config WRTB = OFF    // Configuration Register Write Protection bit->Configuration registers (300000-30000Bh) not write-protected
#pragma config WRTC = OFF    // Boot Block Write Protection bit->Boot Block (000000-0007FFh) not write-protected
#pragma config WRTD = OFF    // Data EEPROM Write Protection bit->Data EEPROM not write-protected
#pragma config WRTSAF = OFF    // SAF Write protection bit->SAF not Write Protected
#pragma config LVP = ON    // Low Voltage Programming Enable bit->Low voltage programming enabled. MCLR/VPP pin function is MCLR. MCLRE configuration bit is ignored

// CONFIG5L
#pragma config CP = OFF    // PFM and Data EEPROM Code Protection bit->PFM and Data EEPROM code protection disabled
//===========================================================


#ifndef Byte
#define Byte  uint8_t
#endif
#ifndef Word
#define Word  uint16_t
#endif

#define ON 1
#define OFF 0
#define SPECIAL 1
#define NORMAL 0
#define VRAI 1
#define FAUX 0
// pour report Alarme   (bit inverse par transistor de sortie)
#define OUI 0
#define NON 1

#define CR 13
#define LF 10
#define TAB 9
#define   Espaces CPrint("    ")

#define UART1_RX_BUFFER_SIZE  128

Word i,j,k,l,m,n;
int Rep;
Byte c1,c2,c3,cx,cc;
Byte temp=0;
volatile Byte Buffer1[UART1_RX_BUFFER_SIZE];
volatile Word Index1=0;
volatile Word i1=0;;
volatile Word  CptErr=0;
volatile Byte Flag_Buffer1=0;

#define RTS             LATCbits.LATC5
#define Affiche_Detail  PORTBbits.RB1
#define SQA             LATAbits.LATA3


Byte TEXTE [128];
Byte * txt;
Byte * p0;
Byte * p1;
Byte * p2;
Byte * px;
Byte CRam1[80];

Byte DTMF_Read =0; 

// compteur Timers
volatile  int Count0, Count1 ;
volatile int Cpt0, Cpt1;
volatile int Flag_Timer1=0;
// pour MSabotage >2
volatile int Cpt4;   // Compteur
volatile signed int  Cpt41;  // decompteur
volatile int Flag_Timer4=0;
volatile Word Count_RB0=0;
volatile Word Count_0_1sec=0;
float F0,F1,F2;
uint32_t L0,L1,L2;
int Res;

volatile unsigned int MaxBlocs;
volatile unsigned int BN;  // numero de blck en cours
volatile unsigned int File_Size=0;

uint32_t  SMT1_Measure;
Byte *ST;

bool Status_GIE_Bit;
 Byte Bavard=0;   // pour debugging
 Byte Etape=0;

volatile struct Anybits {   // 8 flags

       unsigned Tmr0_Elapsed:1;     // for timer0 16bits
       unsigned Tmr1_Elapsed:1;     // for timer1 16bits
       unsigned Tmr2_Elapsed:1;     // for timer2 8bits
       unsigned Tmr3_Elapsed:1;     // for timer3 16bits
       unsigned Tmr4_Elapsed:1;     // for timer4 8bits
       unsigned NCO_initialise:1;   // for NCO
       unsigned RAZ:1;
       unsigned Key_ON:1;
 }Drapeaux ;
 
 // maxima !! 7500 ->  can't find 0x1D4C words (0x1d4c withtotal) for psect "bssBIGRAM" in class "BIGRAM" (
#define MAX_WAVE 6912   // 54x128
 volatile unsigned char Wave_Table[MAX_WAVE];
 
 #include "memory.h" 
 
 #define FLASH_ROW_ADDRESS     0x7D00

 uint8_t wrBlockByte[] =
    {
        0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
        0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F,
        0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F,
        0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F,
        0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F,
        0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F,
        0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F,
        0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F                     
    };
 uint16_t wrBlockWord[] =
    {
        0x1000, 0x1001, 0x1002, 0x1003, 0x1004, 0x1005, 0x1006, 0x1007, 0x1008, 0x1009, 0x100A, 0x100B, 0x10C, 0x100D, 0x100E, 0x100F,
        0x7F10, 0x7F11, 0x7F12, 0x7F13, 0x7F14, 0x7F15, 0x7F16, 0x7F17, 0x7F18, 0x7F19, 0x7F1A, 0x7F1B, 0x7F1C, 0x7F1D, 0x7F1E, 0x7F1F,
        0x8020, 0x8021, 0x8022, 0x8023, 0x8024, 0x8025, 0x8026, 0x8027, 0x8028, 0x8029, 0x802A, 0x802B, 0x802C, 0x802D, 0x802E, 0x802F,
        0xFF30, 0xFF31, 0xFF32, 0xFF33, 0xFF34, 0xFF35, 0xFF36, 0xFF37, 0xFF38, 0xFF39, 0xFF3A, 0xFF3B, 0xFF3C, 0xFF3D, 0xFF3E, 0xFF3F
    };



 
void BCD_To_Ascii(uint8_t  cc, uint8_t * px);
void UART1_Init(void);
void RAZ_UART1_Buffer1(void);
void PrintChar(char txData);
void Print (char * T1);
void CPrint (const char * T1);
void CRLF1(void);
void strConstRamCpy(Byte  *dest, const  Byte *source);
void RAZ_UART1_Buffer1(void);
void Init_Hardware(void);
//void Arme_Timer1(int Max_Timer1);
//void TMR1_Init(void);
void TMR4_Init(void);
void INTERRUPT_Init (void);
void EXT_INT_Init(void);
void Imprime_Asc_Hex( unsigned char * BB , unsigned int N);
void SMT1_Init(void);

void  INTERRUPT_Init (void)
{
    INTCON0bits.IPEN = 1;
    bool state = (unsigned char)GIE;
    GIE = 0;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0; // unlock 
    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 1; // lock IVT
    GIE = state;
    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
    IPR1bits.INT0IP = 1;
    IPR4bits.TMR1IP = 1;
    IPR7bits.TMR4IP = 1;
}

void __interrupt(irq(IRQ_INT0),high_priority) INT0_ISR(void)
{
    if ( ( PIR1bits.INT0IF ==1) && ( PIE1bits.INT0IE==1))
    {
      //  U1TXB='?';
        __delay_ms(2);
        if (PORTBbits.RB0==1)
        {
         Drapeaux.Key_ON=1;
         // Led_V=1;Led_R=0; Led_B=0;
         // Led_Verte_ON
         }
        PIR1bits.INT0IF =0;
      //  PIE1bits.INT0IE=0;
    }
    Count_RB0++;
  }

void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
   static char cx;
   static Word k1;
  //  U1TXB='H';  // pour debugging only
  if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
  {   
      c1=U1RXB;
   //   U1TXB='*'; // echo
  
     if (U1ERRIRbits.ABDOVF==1)    // voir parag  31.2.2.4   page 479
      {
        U1ERRIRbits.ABDOVF = 0 ;
        CptErr++;
        c1=U1RXB ;
       }
       if(U1ERRIRbits.FERIF==1 )
       {
         CptErr++;
         c1 =U1RXB;
       }
        // if ((c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
       Buffer1[i1] = c1;
         // special fichier wave :
         k1=Index1-64 ;
         if(( k1>0) && (k1<MAX_WAVE)) Wave_Table[k1]=c1;
         Index1++;
        i1++;
        switch (Etape)
        {
           case 0:
           if   (i1>63)
           { 
              RTS=1;
                PIE3bits.U1RXIE=0;
                Flag_Buffer1=1;
                i1=0;
                 Etape=1;
            }
           break;
           case 3:
           case 4:    
            if   ((i1>63) || (Index1>File_Size))
            {   RTS=1;
                PIE3bits.U1RXIE=0;
                Flag_Buffer1=1;
            }
            break;
            default:
            break;
         }
  }
}


void __interrupt(irq(IRQ_TMR1),high_priority)TMR1_ISR(void)
{        
  if (  (PIR4bits.TMR1IF==1) && ( PIE4bits.TMR1IE==1) )
  {
      
      if ( Cpt1 < 1)   // x 100ms at 500Khz
      {
      T1CONbits.TMR1ON=0;// stop comptage  timer1
      PIE4bits.TMR1IE=0;
      Drapeaux.Tmr1_Elapsed=1;
      }
      else
      {
       Cpt1--;
      }
      Count_0_1sec ++;
      // 100mS  avec prescaler =1/2  et bascule  1/2
      TMR1H         = 0xCF;  // 53036
      TMR1L         = 0x2C;
      Flag_Timer1=1;
       PIR4bits.TMR1IF=0;
  }
}  


void __interrupt(irq(IRQ_TMR4),high_priority) TMR4_ISR(void)
{  
    if (  (PIR7bits.TMR4IF==1) && ( PIE7bits.TMR4IE==1) )
    {
      Cpt4++;
      if (Cpt41>0)  // decomptage maxi 32767
       {
         Cpt41--;
        }
      else
      {
        Drapeaux.Tmr4_Elapsed=1;   
      } 
      Flag_Timer4=1;
      PIR7bits.TMR4IF=0;// clear the TMR4 interrupt flag
      T4PR=254;
    }       
 }

  


void Imprime_Asc_Hex( unsigned char * BB , unsigned int N)
{ 
  unsigned int  i,j,k,m,l;
  unsigned char Tampon[8];
  k=0;
  m=N>>4;

 if (N<16)
 {
  PrintChar(' ');
    for (i=0;i<N;i++)
    { 
        sprintf(Tampon," %02x.",*(BB+i));
        Print(Tampon);
    }
     CRLF1();
 }
 else
 {
 // Nb entier de blocs 64 bytes
 for (j=0;j<m;j++)
 {
    PrintChar(' ');
    for (i=0;i<16;i++)
    { k= j*16+i;
       sprintf(Tampon," %02x.",*(BB+k));
        Print(Tampon);
     }
     CRLF1();
  }
  // reste un morceuax de bloc ?
   k=m<<4;
   l=N-k;
  if (l>0)
  {
     PrintChar(' ');
     for (j=0;j<l;j++)
     {  
        sprintf(Tampon," %02x.",*(BB+k+j));
        Print(Tampon);
     }
     CRLF1();
   } //if
  } //else 
  CRLF1();
 }


uint32_t SMT1_GetTimerValue()
{
    return (SMT1TMR);
}


void SMT1_Init(void)
{ 
   //04-04-2021
     // registre  SMT1CON0
     SMT1CON0bits.WPOL=0; // Window Polarity
     SMT1CON0bits.SPOL=0; // Signal Polarity
     SMT1CON0bits.CPOL=0; // Clock Polarity
     SMT1CON0bits.SMT1PS1=0; // PS<1:0>: SMT Prescale Select bits = 1/1
     SMT1CON0bits.SMT1PS0=0;    // 00=1/1  11=1/8  10=1/4  01=1/2 
     SMT1CON0bits.SMT1EN =1;    // SMT enabled
     SMT1CON0bits.SMT1STP=0;    // 0 =reset 1=STOP; 
     SMT1CON1bits.SMT1GO =0;    // 1= suit l'entree   0=stop suivi
     SMT1CON1bits.SMT1REPEAT=0; // 0= Single  Acquisition   1=repeat mode
    // REGISTER 25-4: SMT1CLK: SMT CLOCK SELECTION REGISTER 64MHz
    //   001=FOSC      000=FOSC/4    010=HINTOSC 16MHz
    // base de temps sur FOSC=64MHz  15.625nS 
      SMT1CLKbits.CSEL2=  0;
      SMT1CLKbits.CSEL1=  0;
      SMT1CLKbits.CSEL0=  1;
	// 25.7.1 PW (Pulse Width) AND PR (Periode Read)  ACQUISITIONI NTERRUPTS
      PIR1bits.SMT1PRAIF=0;
      PIE1bits.SMT1PRAIE=0;
     //  25.7.2  PERIOD MATCHI NTERRUPT
      PIR1bits.SMT1IF=0;
      PIE1bits.SMT1IE=0;
      // init  compteur
      SMT1PRU=0xFF;
      SMT1PRH=0xFF;
      SMT1PRL=0xFF;
     // MODE de fonctionnement TIMER  page 396  
     //   0000=Timer   0100=windowed measure  1000=counter
     //SMT1CON1=0;
     SMT1CON1bits.MODE3=0;
     SMT1CON1bits.MODE2=0;
     SMT1CON1bits.MODE1=0;
     SMT1CON1bits.MODE0=0;
  }

void UART1_Init(void)
{
    U1P1L = 0x00;
    U1P1H = 0x00;
    U1P2L = 0x00;
    U1P2H = 0x00;
    U1P3L = 0x00;
    U1P3H = 0x00;
    U1CON0 = 0xB0; // BRGS high speed; MODE Asynchronous 8-bit mode; RXEN enabled; TXEN enabled; ABDEN disabled; 
    // RXBIMD Set RXBKIF on rising RX input; BRKOVR disabled; 
    // WUE disabled; SENDB disabled; ON enabled; 
    U1CON1 = 0x80;    
    // TXPOL not inverted; FLO off; C0EN Checksum Mode 0; RXPOL not inverted;
    //RUNOVF RX input shifter stops all activity; STP Transmit 1Stop bit, receiver verifies first Stop bit; 
   
    // 115200 at FOSC 64MHz 
   U1CON2 = 0x00;
   U1BRGL = 0x8A; // BRGL 138;   115200 bds
    U1BRGH = 0x00; // BRGH 0; 
    
// SPEED  19200 bds at FOSC =64MHz
// BRG=833;
// U1BRGL=64;// U1BRGL = 0x40;
// U1BRGH=3;// U1BRGH = 0x03;
    
    U1FIFO = 0x00; // STPMD in middle of first Stop bit; TXWRE No error; 
   // ABDIF Auto-baud not enabled or not complete; 
    // WUIF WUE not enabled by software; ABDIE disabled; 
    U1UIR = 0x00;
    // ABDOVF Not overflowed; TXCIF 0; RXBKIF No Break detected; 
    // RXFOIF not overflowed; CERIF No Checksum error; 
    U1ERRIR = 0x00;
    // TXCIE disabled; FERIE disabled; TXMTIE disabled; ABDOVE disabled;
    // CERIE disabled; RXFOIE disabled; PERIE disabled; RXBKIE disabled; 
    U1ERRIE = 0x00;
    U1CON0bits.TXEN=1;
    U1CON0bits.RXEN=1;
  /* REGISTER 31-3: UxCON2: UART CONTROL REGISTER 2  
     bit 1-0 FLO[1:0]: Handshake Flow Control bits
    11 = Reserved
    10 = RTS/CTS and TXDE Hardware flow control
    01 = XON/XOFF Software flow control
    00 = Flow control is off
    RUNOVF =1   RX input shifter continues to synchronize with Start bits after overflow condition
    FLO[1:0]: Handshake Flow Control bits= 10 = RTS/CTS and TXDE Hardware flow control 
    U1CON2 = 0x80 | 0x02;
    */
    U1CON2=0x80;
    PIE3bits.U1RXIE = 0;  // disable receive interrupt
}


void strConstRamCpy(Byte  *dest, const  Byte *source)
 { static Byte cc=0;
 cc= *(source);
  while ( cc>0 )
  { cc=*(source);
    *(dest++) =cc;
    source++ ;
  }
  *(dest) = 0 ;    // terminateur
}

void PrintChar(char txData)
{
    while(PIR3bits.U1TXIF==0);
       U1TXB = txData;    // Write the data byte to the USART.
}

 void Print (char * Tc)
 { static uint16_t k;
   k=0;      
   while(*(Tc+k)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(Tc+k);
    k++;
    if(k>128)break;
   }
}
 
 
  void CPrint (const char *T1)
 { 
   while(*(T1)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(T1);
    T1++;
   }
}

void CRLF1(void)
{
   while(PIR3bits.U1TXIF==0);
   U1TXB=13;
    while(PIR3bits.U1TXIF==0);
   U1TXB=10;  
  }    


void Float2Ascii (float x, unsigned char *str,char precision)
{
 // converts a floating point number to an ascii string
 // version limitee  6 decimales maximum
 // x is stored into str, which should be at least 30 chars long
static int ie, i, k, ndig;
 static double y;
  ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 // if x negative, write minus and reverse
 if ( x < 0.0000)
 {
   *str++ = '-';
   x = -x;
 }
 // put x in range 1 <= x < 10
 if (x > 0.00000) while (x < 1.00000)
 {
   x *= 10.000;                // a la place de =*
   ie--;
 }
 while (x >= 10.000)
 {
   x = x/10.000;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.000;
 x += y/2.000;
 if (x >= 10.000) {x = 1.000; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = (uint16_t) x; 
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.000;
  }
 *str = '\0';
}


void TMR4_Init_500ms(void)
{   
    //  cycle=500 mS
     PIE7bits.TMR4IE=0;
     // T2PSYNC Not Synchronized; T2MODE Software control; T2CKPOL Rising Edge; T2CKSYNC Not Synchronized; 
    T4CLKCON = 0x05;    // T2CS FOSC/4 ou    0x05 pour 500Khz
    T4HLT = 0x00;
    T4PR = 243; // PR4 255; 
    T4TMR = 0x00;  // TMR4 0; 
    PIR7bits.TMR4IF = 0;  // Clearing IF flag.
    T4CON = 0x70 | 0x07 ; // Prescaler =1/128 Poscaler=1/8 =>  ticks= 1024  S
    T4PR=243; // PR2    =n-1=244-1
    Drapeaux.Tmr4_Elapsed=0;
   IPR7bits.TMR4IP=0; // low priority
   T4CONbits.TMR4ON = 0;
   PIR7bits.TMR4IF=0;
   PIE7bits.TMR4IE=1;
}

void TMR4_Init_100ms(void)
{   
    // tourne en 100 mS
    PIE7bits.TMR4IE=0;
     // T2PSYNC Not Synchronized; T2MODE Software control; T2CKPOL Rising Edge; T2CKSYNC Not Synchronized; 
    T4CLKCON = 0x05;    // T2CS FOSC/4 ou    0x05 pour 500Khz
    T4HLT = 0x80;
    T4TMR = 0x00;  
 //   T4CON =( 0x70 | 0x03 ) ; // Prescaler =1 / 128 Postcaler =1 / 4 =>  ticks= 1024  S
 //   T4PR=97; // PR4=0xFF => 97x1024=100000S => 100 mS
   T4CON =( 0x60 | 0x02 ) ; // Prescaler =1/64 Poscaler=1/3 =>  ticks= 384  S
   T4PR=254; // PR4+1=0xFF => 334x255 =~100mS
   Drapeaux.Tmr4_Elapsed=0;
   Flag_Timer4=0;
   IPR7bits.TMR4IP=1; 
   PIR7bits.TMR4IF = 0;  // Clearing IF flag.
   Cpt4=0; 
   PIE7bits.TMR4IE=1;
   T4CONbits.TMR4ON = 1;
}


/*
void Init_TMR2_for_TimeOut_RxUART1()
{
//configure HLT2 for a 5 ms timeout of no activity on U1RX:
 T2PR = 0x9C ;//(156 prescale periods)
 T2CLKCON = 0x05;//(500 kHz internal oscillator)
 T2HLT = 0x04 ;//(free running, reset on rising edge)
 T2RST = 0x15;// (reset on U1RX)
 T2CON = 0xC0;// (Timer2 on with 1:16 prescale)
}
*/ 


void Init_Timer2()
{ 
  T2CON    = 0x00;
  
  // resolution 9 bits  => maxi 100% duty avec consigne < 720 points
  T2CONbits.CKPS=3;  // div 1/8     
  T2CONbits.OUTPS=0;  // div 1/1 .......  NOT USED with CCP1 ,only as free Timer
  T2PR=180;  // 0.0625 * 2 * 3 * 240 =90.35 S  =>  11065 Hz
  T2TMR=0;
  T2CLK=0x01; //1= FOSC/4    2=FOSC     5=500Khz   
 // REGISTER 22-2: TxRST: TIMER2 EXTERNAL RESET SIGNAL SELECTION REGISTER p337
  T2RST=0x04;  // CCP1OUT
  PIE4bits.TMR2IE=0;
  PIR4bits.TMR2IF=0;
  T2CONbits.T2ON=1;
}

void CCP1_PWM_Config(void)
 {
    CCP1CON=0;
    CCP1CONbits.CCP1FMT =0;  // right alignment
    CCP1CONbits.CCP1MODE3 =1;   //PWM 0b1100';        //   table 22-1  p322
    CCP1CONbits.CCP1MODE2 =1;
    CCP1CONbits.CCP1MODE1 =0;
    CCP1CONbits.CCP1MODE0 =0;
  //  REGISTER 23-2: CCPTMRS0: CCP TIMERS CONTROL REGISTER 0
  //  01 = CCP1 is based off Timer2 in PWM mode
    CCPTMRS0bits.C1TSEL1=0;
    CCPTMRS0bits.C1TSEL0=1;
    CCP1CAP=0;
    CCP1CONbits.EN=1; 
}





void Init_Timer1(void)
 {
//  usage de MFINOSC  500Khz
//Timer1
//Prescaler 1:4;  TMR1 Preload = 53036= 0xCF2C ; Actual Interrupt Time : 100 ms
    PIE4bits.TMR1IE=0;
  // T1CLK=1; //  FOSC/4   => 16MHz !
  T1CLK=5; //  MFINTOSC 500KHz
  T1CON=0;
  T1GATE=0;
  T1CONbits.T1CKPS1=1; // CKPS1   diviseur 1/4
  T1CONbits.T1CKPS0=0;
  T1CONbits.RD16=0;
  T1CONbits.NOT_SYNC=0;
  TMR1H         = 0xCF;  // 53036
  TMR1L         = 0x2C;
  INTCON0bits.IPEN=0;
  IPR4bits.TMR1IP=1; // Low level interrupt
   if(Cpt1==0) Cpt1=4; // soit 1sec par defaut
  Drapeaux.Tmr1_Elapsed=0;
   PIR4bits.TMR1IF=0;
   T1CONbits.TMR1ON=0;   //  TMR1 Off
}

   
 void Arme_Timer1(int Max_Timer1)
{
   // 100 mS * Max_Timer1  (at 500Khz)
  Drapeaux.Tmr1_Elapsed=0;
  Cpt1=   Max_Timer1;
  T1CONbits.RD16=1;
   TMR1H         = 0xCF;  // 53036
   TMR1L         = 0x2C;
   PIR4bits.TMR1IF=0;
   PIE4bits.TMR1IE=1;
    T1CONbits.TMR1ON=1;  // Timer1 ON
  } 
 

void Init_Hardware()
{
    LATA = 0x00;
    TRISA = 0b1000011;
    ANSELA = 0x00;
    WPUA = 0x00;
    ODCONA = 0x00;
    SLRCONA = 0xFF;
    INLVLA = 0xFF;
    SQA=0;
 
    LATB = 0x00;
    TRISB = 0b11000111;
    ANSELB = 0x00;
    RB1PPS=0;
    RB1I2C = 0x00;
    RB2I2C = 0x00;
    INT0PPS = 0x08;   //RB0->EXT_INT:INT0;
    WPUB = 0x03;  // pull up sur RB0 et RB1
    ODCONB = 0x00;
    SLRCONB = 0xFF;
    INLVLB = 0xFF;
    
    LATC = 0x00;
    TRISC = 0b10001001;
    ANSELC = 0x00;
    RC0PPS=0;
    RC1PPS=0x09 ;// CCP1 sur RC1  TABLE 17-2: PPS OUTPUT REGISTER DETAILS p283
    RC2PPS=0;
    RC3PPS=0;
    RC4PPS=0;
    RC5PPS=0; // gestion manuelle de RTS
    //RC5PPS=0x15; // TABLE 17-2: PPS OUTPUT REGISTER  p282  0b01 0101 UART1 (RTS) ? B C
#ifdef With_NCO
    // pour NCO
    //RC4PPS=0x26; //RC4->NCO1:NCO1;
#endif
    RC6PPS = 0x13;   //RC6->UART1:TX1;    
    U1RXPPS = 0x17;   //RC7->UART1:RX1; 
    RTS=1;
    ODCONC = 0x00;
    SLRCONC = 0x0F;
    INLVLC = 0xFF;
    WPUC = 0xFF;
   
}    
  
void RAZ_UART1_Buffer1(void)
{  if (PIR3bits.U1RXIF==1)   c1=U1RXB ;
   RTS=1;
    for (i1=0;i1<sizeof(Buffer1)-1;i1++) Buffer1[i1]=0;
      PIE3bits.U1IE  = 1;       // int uart1 enabled
      U1CON0bits.RXEN=1;
      U1ERRIR = 0x00;
      U1ERRIE = 0x00;
      c1=0;
      Buffer1[0]=0;
      Flag_Buffer1=0;
      i1=0;
      //Index1=0;
      c1=0;
      RTS=0;
      PIE3bits.U1RXIE =1;  
} 


void main(void)
{
  // from MCC      OSCILLATOR_Initialize();
   OSCCON1 = 0x60; // NOSC HFINTOSC; NDIV 1;
   OSCCON3 = 0x00;// CSWHOLD may proceed; SOSCPWR Low power; 
   OSCEN = 0x00;  // MFOEN dis; LFOEN dis; ADOEN dis; SOSCEN dis; EXTOEN dis; HFOEN dis; 
   OSCFRQ = 0x08;  // HFFRQ 64_MHz;
   OSCTUNE = 0x00;// TUN 0; 
    __delay_ms(500);
    
    //REGISTER 8-1: CLKRCON: REFERENCE CLOCK CONTROL REGISTER  p113
    CLKRCON=0b10010000;
    //REGISTER 8-2: CLKRCLK: CLOCK REFERENCE CLOCK SELECTION MUX
    CLKRCLK=3; // 500Khz
    __delay_ms(500);
    
    Init_Hardware();
    CM1CON0=0;
    CM1CON1=0;
    INTERRUPT_Init();
    
    // on occupe et nettoie les places reservees
    k= sizeof(Buffer1)-1;
    for (i=0;i<k;i++) Buffer1[i]=0;
    for (i=0;i<sizeof(CRam1)-1;i++) CRam1[i]=0;
    for (i=0;i<sizeof(TEXTE)-1;i++) TEXTE[i]=0;
    txt=&TEXTE[0];
    
    UART1_Init();
    
    txt= &TEXTE[0];
    *(txt)=0; 
    CRLF1(); 
    Cpt1=0;
    Cpt4=0;
    Cpt41=10; // par defaut 10x100=> 1sec
    Count_RB0=0;
    
    Flag_Buffer1=0;
    CRLF1();
    CPrint(" Projet MPLABX :18F27K42_Test_Ecr_Lec_Flash_2022-09.X\r\n");
    CPrint(" Version : "VERSION"\r\n"); 
     k=sprintf(txt," Compile le %s a %s UTC\r\n avec version XC8 :  %d\r\n", __DATE__, __TIME__,__XC8_VERSION);
    Print(txt);
    CPrint(" Hardware : PIC18F27K42 , FOSC interne =64MHz \r\n");
    CPrint(" UART1 Hardware RC6=TX  RC7=RX  115200,8,N,1  Interrupt High sur RX \r\n");
    CPrint(" Usage de Timer1 x fois 100mS , Timer4  100mS\r\n");
    CPrint(" Usage de Timer2 et CCP1 pour PWM 11025 Hz sur RC1\r\n");
    CRLF1();

    Bavard=1;
    
      
  
#ifdef With_SMT1
     CPrint(" Init Compteur 24 bits SMT1, base de temps : FOSC 64MHz\r\n");
     SMT1_Init();
    SMT1_Measure=0;
    ST=&SMT1_Measure;
// SMT1CLKbits.CSEL2=  1;  // 500Khz
    SMT1CLKbits.CSEL2=  0;  // set base de temps SMT1 sur FOSC =64MHz
    SMT1CLKbits.CSEL1=  0;
    SMT1CLKbits.CSEL0=  0;
    CPrint(" Test SMT1 sur 10mS : ");
    SMT1STATbits.RST=1;
    SMT1CON1bits.SMT1GO=1;
    __delay_ms(10);
    SMT1CON1bits.SMT1GO=0;
    *(ST)=SMT1TMRL;
    *(ST+1)=SMT1TMRH;
    *(ST+2)=SMT1TMRU;
    *(ST+3)=0;
   // SMT1_Measure= SMT1_GetTimerValue();
     CPrint( " Stop SMT1   Nb Tics avec ultoa -> ");
     ultoa(txt,SMT1_Measure,10);
     Print(txt);
     CPrint(" , soit ");
     if (SMT1CLKbits.CSEL2==1) 
      L1=SMT1_Measure<<1;   
      else
        L1=SMT1_Measure>>4;   
     Print(ltoa(CRam1,L1,10));
     CPrint (" uS\r\n");
     CRLF1();
#endif  
    
    
    
    
    
    
    
    
   //================================================
    
#ifdef With_Test_flash  
    
    CRLF1();
    CPrint(" Test1 Lecture 64 Bytes Flash at @ 0x7D00 soit 32000 \r\n"); 
    for (i=0;i<64;i++)
    {   if(i%16==0)
        {
            CRLF1();
            sprintf(CRam1," %u -> ",FLASH_ROW_ADDRESS+(i<<1));
            Print(CRam1);
        }
        cx= FLASH_ReadByte(FLASH_ROW_ADDRESS+(i<<1));
        sprintf(CRam1,"0x%02x.",cx);
        Print(CRam1);
    }    
    CRLF1();CRLF1();
          
    CPrint(" Test2 ecriture Bloc 64 Bytes data en Flash at @ 0x7D00 soit 32000 \r\n"); 
  //  int8_t FLASH_WriteBlock(uint32_t writeAddr, uint8_t *flashWrBufPtr)
    k=FLASH_WriteBlock(FLASH_ROW_ADDRESS, wrBlockByte);
    sprintf(txt," retour k=%5d\r\n",k);
    Print(txt);
    CRLF1();
     
    
    CPrint(" Test3 Re-Lecture Bytes en  Flash at @ 0x7D00 soit 32000 \r\n"); 
    for (i=0;i<64;i++)
    {  if (i%16==0)
         {
           CRLF1();
           sprintf(CRam1," %u -> ",FLASH_ROW_ADDRESS+(i<<1));
           Print(CRam1);
         }
        cx= FLASH_ReadByte(FLASH_ROW_ADDRESS+i);
        sprintf(CRam1,"0x%02x.",cx);
        Print(CRam1);
    }    
    CRLF1();
    
  
    CRLF1();
    CPrint(" Test5 : Efface Bloc 128 Bytes  en Flash at @ 0x7D00 soit 32000 \r\n");
    FLASH_EraseBlock(FLASH_ROW_ADDRESS);
     CRLF1();
    
     CPrint(" Test6 : Lecture 64 Word Flash at @ 0x7D00 soit 32000 \r\n"); 
    for (i=0;i<64;i++)
    {   if(i%16==0)
        {
            CRLF1();
            sprintf(CRam1," %u -> ",FLASH_ROW_ADDRESS+(i<<1));
            Print(CRam1);
        }
        k = FLASH_ReadWord(FLASH_ROW_ADDRESS+(i<<1));
        sprintf(CRam1,"0x%04x.",k);
        Print(CRam1);
    }    
    CRLF1();CRLF1();
    
    
     CPrint(" Test7 : ecriture Bloc 64  WORD data en Flash at @ 0x7D00 soit 32000 \r\n"); 
     //  int8_t FLASH_WriteBlock(uint32_t writeAddr, uint8_t *flashWrBufPtr)
    k=FLASH_WriteBlock(FLASH_ROW_ADDRESS,wrBlockWord);
    sprintf(txt," retour k=%5d\r\n",k);
    Print(txt);
    CRLF1(); 
    
    CPrint(" Test8 : Re-Lecture 64 WORD en  Flash at @ 0x7D00 soit 32000 \r\n"); 
    for (i=0;i<64;i++)    
    { 
         if (i%16==0)
         {
           CRLF1();
           sprintf(CRam1," %u -> ",FLASH_ROW_ADDRESS+(i<<1));
           Print(CRam1);
         }
       k= FLASH_ReadWord(FLASH_ROW_ADDRESS+(i<<1));
        sprintf(CRam1,"0x%04x.",k);
        Print(CRam1);
    }    
    CRLF1();
    
    
     CPrint("------ fin du 1er Test Flash .. adressage Flash modulo word ---r\n");
     CRLF1();

     CRLF1();
     CPrint("---- 2em  Test Flash .. adressage Flash modulo Byte -------\r\n");
     CRLF1();
     
     CPrint(" Test 1A : Efface Bloc 128 Bytes  en Flash at @ 0x7D00 soit 32000 \r\n");
     FLASH_EraseBlock(FLASH_ROW_ADDRESS);
     CRLF1();
    
    CRLF1();
    CPrint(" Test 2A Lecture 128 Bytes Flash at @ 0x7D00 soit 32000 \r\n"); 
    for (i=0;i<128;i++)
    {   if(i%16==0)
        {
            CRLF1();
            sprintf(CRam1," %u -> ",FLASH_ROW_ADDRESS+i);
            Print(CRam1);
        }
        cx= FLASH_ReadByte(FLASH_ROW_ADDRESS+i);
        sprintf(CRam1,"0x%02x.",cx);
        Print(CRam1);
    }    
    CRLF1();CRLF1();
    
    
       CPrint(" Test 3A ecriture Bloc 128 Bytes data en Flash at @ 0x7D00 soit 32000 \r\n"); 
  //  int8_t FLASH_WriteBlock(uint32_t writeAddr, uint8_t *flashWrBufPtr)
    k=FLASH_WriteBlock(FLASH_ROW_ADDRESS, wrBlockByte);
    sprintf(txt," retour k=%5d\r\n",k);
    Print(txt);
    CRLF1();
    CRLF1();

    CPrint(" Test 4A Re-Lecture 128 Bytes en  Flash at @ 0x7D00 soit 32000 \r\n"); 
    SMT1_Measure=0;
    SMT1STATbits.RST=1;
    SMT1CON1bits.SMT1GO=1; 
    for (i=0;i<128;i++)
    {  //if (i%16==0)
       //  {
         //  CRLF1();
        //   sprintf(CRam1," %u -> ",FLASH_ROW_ADDRESS+i);
        //   Print(CRam1);
        // }
        cx= FLASH_ReadByte(FLASH_ROW_ADDRESS+i);
       // sprintf(CRam1,"0x%02x.",cx);
       // Print(CRam1);
    }
    SMT1CON1bits.SMT1GO=0;
    *(ST)=SMT1TMRL;
    *(ST+1)=SMT1TMRH;
    *(ST+2)=SMT1TMRU;
    *(ST+3)=0;
     CRLF1();
      CPrint(" Duree relecture 128 bytes en flash  :");
     L1=SMT1_Measure>>4;   
     Print(ltoa(CRam1,L1,10));
     CPrint (" uS\r\n");
     CRLF1();
    
    
    CRLF1();
    CPrint("--- fin du 2em Test Flash .. adressage Flash modulo Byte------\r\n");
     CRLF1();
    CRLF1();
    
#endif  

 //===========================================
      
  
    
    
    
#ifdef With_EXTERNAL_IT
     CPrint(" Init Interruption externe RB0 \r\n");
     Count_RB0=0;
     EXT_INT_Init();
      
#endif
    
     Cpt1=0;
     txt= &TEXTE[0];
     *(txt)=0; 
     CRLF1(); 
               
    INTERRUPT_Init ();
  
    T1CONbits.TMR1ON = 0;
    T4CONbits.TMR4ON = 0;
    PIR1bits.INT0IF =0;
    
    CPrint(" Arme IVT interrupts  18F27K42\r\n");
    PIE3bits.U1RXIE =1;
    PIE4bits.TMR1IE = 0;
    PIE7bits.TMR4IE = 1;
    PIE1bits.INT0IE=0;
    INTCON0bits.GIEL = 1;
    INTCON0bits.GIEH=1;
  

#ifdef With_SMT1_500khz
    // base de temps SMT1 sur MFINTOSC=500Khz
    CPrint(" Set Horloge clock SMT1 sur 500Khz pour mesure de longue duree >1sec \r\n");
    SMT1CLKbits.CSEL2=  1;
    SMT1CLKbits.CSEL1=  0;
    SMT1CLKbits.CSEL0=  0;
    CPrint("Test SMT1 sur 1000mS : ");
    SMT1_Measure=0;
    SMT1STATbits.RST=1;
    SMT1CON1bits.SMT1GO=1;
    __delay_ms(1000);
    SMT1CON1bits.SMT1GO=0;
    SMT1_Measure= SMT1_GetTimerValue();
    CPrint( " duree -> ");
    L1=SMT1_Measure<<1;    // * 2
    F1=(float) L1/1000.0;
   // Print(ltoa(CRam1,L1,10));
   // PrintChar(9);
    Float2Ascii(F1,CRam1,3);
    Print(CRam1);
    CPrint (" mS\r\n");   
#endif     
     
    CPrint(" Timer1 init 100mS \r\n");
    Init_Timer1();
   CPrint("Test Timer1 arme pour 30 x 100msec\r\n");
    Arme_Timer1(30);
    CPrint(" Arme \r\n"); 
    do
    {
      while(Flag_Timer1==0);
      k=Count_0_1sec;
      cx=(char)(k % 10) +48;
      PrintChar(cx);
      Flag_Timer1=0;
    }
    while(Drapeaux.Tmr1_Elapsed==0);
    Drapeaux.Tmr1_Elapsed=0;
    T1CONbits.TMR1ON=0;
    CPrint("\r\n Stop\r\n"); 
    CRLF1();
    
   CPrint(" Test Timer4  decompte sur 40 boucles (x100mS)\r\n"); // 
   CPrint(" Start\r\n");
   Cpt4=0;
  
   Flag_Timer4=0;
   Cpt41=40;
   TMR4_Init_100ms();
   do
    {  
     while(Flag_Timer4==0); // Flag_Timer4 sur interrupt
     k=Cpt41;
     cx=(char)(k % 10) +48;
     PrintChar(cx);
     Flag_Timer4=0;
    }
    while(Drapeaux.Tmr4_Elapsed==0); // Drapeaux sur decomptage attient
    CPrint("\r\nStop\r\n");
    CRLF1();

 
    
   CRLF1(); 
 
   CPrint(" Init CCP PMW1 on RC1\r\n");
   CCP1_PWM_Config();
     CPrint("\r\n Init Timer2  90S\r\n");
   Init_Timer2(); 
   k=128;
   // suivant config FORMAT   voir FIGURE 23-5: PWM 10-BIT ALIGNMENT  p349
   CCPR1L  = (k & 0x00FF);      //   Writing  LSB of PWM duty cycle
   CCPR1H = ((k & 0x03FF)>>8) ; //  Writing 2 bits MSB of PWM duty cycle

   CRLF1(); 
   CPrint("\r\n....verif Freq. PWM =90S , pendant  timeout 20sec\r\n"); 
   CPrint(" Duty value au clavier  k=XXXX (1024 pour sortir du test \r\n");
   Index1=0;
   Etape=0;
   do
   {  
        Init_Timer1(); 
        RAZ_UART1_Buffer1();
        Arme_Timer1(200);
        while( (i1<6) && (Drapeaux.Tmr1_Elapsed==0));
        if(Drapeaux.Tmr1_Elapsed==0)
        {   
            sprintf(txt,"\r\n Reu %5d bytes \r\n %s \r\n",i1,Buffer1);
            Print(txt);
           if(  (*(Buffer1)=='k') && (*(Buffer1+1)=='=') && (strlen(Buffer1)>5)   )
            {
               SQA=1;
               *(Buffer1+6)=0;
                k=atoi( Buffer1+2);   
                CCPR1L  = (k & 0x00FF);      //   Writing  LSB of PWM duty cycle
                CCPR1H = ((k & 0x03FF)>>8) ; //  Writing 2 bits MSB of PWM duty cycle
               
                sprintf(txt," new PWM duty cycle = %5d\r\n",k);
                Print(txt);
                 SQA=0;
             }
        } 
   }
   while(k<1024);
   RTS=1;


   //===========================  a suivre ==================================== 
   CPrint("\r\n..Saisie et envoi fichier *.wav via TERATERM terminal Send file\r\n"); 
   Index1=0;
   Etape=0;
  while(Etape<6)
  { RTS=1;
     switch (Etape)
     {    
        case 0:
           CRLF1(); 
           CPrint(" Etape 0\r\n.. Attente  IT RX UART1\r\n");
            i1=0;
            RAZ_UART1_Buffer1() ;   // arme Interrupt UART Rx
            __delay_ms(1000);
             break;
        case 1:
            CPrint("Etape 2\r\n Reu :\r\n");
             strncpy(CRam1,Buffer1,64);
             Print(CRam1);
             CRLF1();
            Imprime_Asc_Hex( Buffer1,64);
            strConstRamCpy(CRam1,"RIFF");
            p1=strstr(Buffer1,CRam1);
            if (p1 != NULL)
            { 
                  
               // Print(CRam1);CRLF1();
                CPrint(" Fichier RIFF !\r\n");
                CPrint(" Global File size = ");
                k=*(p1+5);k=k<<8 ; k=k+ *(p1+4)+8;
                File_Size=k;
                sprintf(CRam1,"  Global File size = %5d bytes\r\n",File_Size);
                Print(CRam1);
            }
            else
            {
                Etape=0;
                break;
            }    
            // on ne peut plus continuer  utiliser les fonctions string car pas de zero terminateur
            strConstRamCpy(CRam1,"WAVEfmt ");
            p1=strstr(Buffer1+8,CRam1);
            if (p1 != NULL)
            {
                CPrint(" Fichier WAVfmt  ..OK\r\n");
                __delay_ms(100);
                Etape=3;
             }
             else
             {
               sprintf(CRam1," j= %5d ",j);
               Print(CRam1);CRLF1();
                Etape=0;
                Index1=0;
                CPrint("\r\nCe n'est pas un WAV !!!...\r\n");
             }
              break;   
         case 3:
            CRLF1();
            p1=&Buffer1[0];   
            //   Imprime_Asc_Hex( p1,44);
            CPrint("Etape 2   Format chunk :\r\n");
             CPrint(" Taille Bloc =");
             p1=&Buffer1[16];  //         Imprime_Asc_Hex( p1,4);
            memcpy(CRam1,p1,4);      //    Imprime_Asc_Hex( p1,4);
             k=*(p1+1);k=k<<8 ; k=k+ *(p1);
             sprintf(CRam1," Taille Bloc = %5d Bytes\r\n",k);
             Print(CRam1);
            CRLF1();
         
            p1=Buffer1+20;
            memcpy(CRam1,p1,2);
            Imprime_Asc_Hex(p1,2);
            k=*(p1+1);k=k<<8 ; k=k+ *(p1);
            sprintf(CRam1," Format PCM = %5d\r\n",k);
            Print(CRam1);
            CRLF1();

            p1=Buffer1+22;
            memcpy(CRam1,p1,2);   
            Imprime_Asc_Hex( p1,2);
            k=*(p1+1);k=k<<8 ; k=k+ *(p1);
            sprintf(CRam1," Nb CanauxM = %5d\r\n",k);
            Print(CRam1);
          
            p1=Buffer1+24;
            memcpy(CRam1,p1,4);  
            Imprime_Asc_Hex( p1,4);
            k=*(p1+1);k=k<<8 ; k=k+ *(p1);
            sprintf(CRam1," Freq. Echantill.= %5d Hz\r\n",k);
            Print(CRam1);
           

            CPrint(" >");
            p1=Buffer1+36;
            PrintChar(*(p1));PrintChar(*(p1+1));PrintChar(*(p1+2));PrintChar(*(p1+3));
            memcpy(CRam1,p1,4);    
            CRLF1();
            Imprime_Asc_Hex(p1,4);
            CRLF1();

            CPrint(" Taille Data = ");
            p1=Buffer1+40;
            memcpy(CRam1,p1,4);
            Imprime_Asc_Hex( CRam1,4);
             k=*(p1+1);k=k<<8 ; k=k+ *(p1);
            File_Size=k;
            sprintf(CRam1," Taille Data = %5d bytes \r\n",k);
            Print(CRam1);
            MaxBlocs=k>>6;  //  31-08-2022
            sprintf(CRam1," Max Blocs =%5d \r\n",k);
            Print(CRam1);
            CRLF1();
            Etape=4;
            Index1=0;  // Nb de datas lues
            i1=0;
            k=0;
            break;
         case 4:
            RTS=1;
            CPrint(" Etape 3 ; lecture des datas :");
            sprintf(CRam1," lecture des datas : %5d bytes\r\n",File_Size);
            Print(CRam1);
            CRLF1();
            Etape=4;
            BN=1;
            CPrint("\r\n reste du Bloc #1 \r\n");
            p1=Buffer1+44 ;
            Imprime_Asc_Hex( p1,20);
            CRLF1();
            CPrint(" Affichage Datas blocs (si RB1=0)  valeur RB1= ");
            cx= Affiche_Detail +48; // PORTBbits.RB1+48;
            PrintChar(cx);
            CRLF1();  CRLF1();
            Index1=64;
            i1=0;
         __delay_ms(1000);
         while( (Index1<File_Size-64) && (BN<MaxBlocs))
         {
             RAZ_UART1_Buffer1();
            __delay_ms(45);       // minima is 19200/10=1920 bytes/sec  64bytes en 33ms
            if(Flag_Buffer1==1)
             {  
               BN++;   // Block number
               cx=PORTBbits.RB1;
               if(cx==0)
               {
               sprintf(CRam1,"\r\n Bloc #%5d  Offset=%5d\r\n",BN,Index1-64);
               Print(CRam1);
               p1=Buffer1 ;
               Imprime_Asc_Hex( p1,64);
                }
                else
                {
                  sprintf(CRam1," Bloc #%5d \r\n",BN);
                  Print(CRam1);
                }
             }
           }
           CPrint("\r\n Fin de lecture data wave\r\n");
           RTS=1;
           Etape=5;
           __delay_ms(2000);
           break;
         case 5:
             j=0;
             CPrint(" Etape 5 \r\n");
             CPrint(" re Start CCP1 PWM1 8bits at 11025 on RC1, duty=k=value 512 \r\n");
             CCP1CONbits.EN=1; 
             T2CONbits.T2ON=1;
            do
            {
               CPrint("\r\n ---------------------------\r\n");
               CPrint("    Joue le fichier wave 11025 Hz en 8 bits \r\n");
               CPrint("---------------------------\r\n") ;
               CCPR1H=0;
               for (i=0;i<MAX_WAVE;i++)
               {
                SQA=1;
                CCPR1H=0;
                CCPR1L  = Wave_Table[i] ; 
                __delay_us(88);
                SQA=0;
               }
               CCPR1H=0;
               CCPR1L  =128 ; 
               __delay_ms(2000);
               j++;
            } while(j<5);
            Etape=6;
            break;
         case 6:
              CCP1CONbits.EN=0; 
              T2CONbits.T2ON=0;
              CPrint("\r\n ------- fin de tests ------ \r\n");
              Etape=7;
              break;
        default:
              break;
     }  // switch
  }  // while 1
   CPrint("\r\n -----END ----- \r\n");
   while(1);  
 
}
  
/*
 * 
CLEAN SUCCESSFUL (total time: 93ms)
make -f nbproject/Makefile-default.mk SUBPROJECTS= .build-conf
make[1]: Entering directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'
make  -f nbproject/Makefile-default.mk dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.hex
make[2]: Entering directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -c   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=wordwrite -O0 -fasmfile -maddrqual=ignore -xassembler-with-cpp -mwarn=-3 -Wa,-a -DXPRJ_default=default  -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits -mc90lib   -std=c90 -gdwarf-3 -mstack=compiled:auto:auto:auto     -o build/default/production/main.p1 main.c 
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -c   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=wordwrite -O0 -fasmfile -maddrqual=ignore -xassembler-with-cpp -mwarn=-3 -Wa,-a -DXPRJ_default=default  -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits -mc90lib   -std=c90 -gdwarf-3 -mstack=compiled:auto:auto:auto     -o build/default/production/memory.p1 memory.c 
main.c:419:15: warning: (346) declaration of "i" hides outer declaration
main.c:419:17: warning: (346) declaration of "j" hides outer declaration
main.c:419:19: warning: (346) declaration of "k" hides outer declaration
main.c:419:21: warning: (346) declaration of "m" hides outer declaration
main.c:419:23: warning: (346) declaration of "l" hides outer declaration
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -Wl,-Map=dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.map  -DXPRJ_default=default  -Wl,--defsym=__MPLAB_BUILD=1   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=wordwrite -O0 -fasmfile -maddrqual=ignore -xassembler-with-cpp -mwarn=-3 -Wa,-a -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits -mc90lib -std=c90 -gdwarf-3 -mstack=compiled:auto:auto:auto      -Wl,--memorysummary,dist/default/production/memoryfile.xml -o dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.elf  build/default/production/main.p1 build/default/production/memory.p1     
Non line specific message::: advisory: (1492) using updated 32-bit floating-point libraries; improved accuracy might increase code size

Memory Summary:
    Program space        used  3DA4h ( 15780) of 20000h bytes   ( 12.0%)
    Data space           used  1E0Eh (  7694) of  2000h bytes   ( 93.9%)
    Configuration bits   used     5h (     5) of     5h words   (100.0%)
    EEPROM space         used     0h (     0) of   400h bytes   (  0.0%)
    ID Location space    used    10h (    16) of    10h bytes   (100.0%)

make[2]: Leaving directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'
make[1]: Leaving directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'

BUILD SUCCESSFUL (total time: 11s)
Loading code from C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X/dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.hex...
Program loaded with pack,PIC18F-K_DFP,1.6.125,Microchip
Loading completed


*/
